/* keybindings.c generated by valac 0.22.1, the Vala compiler
 * generated from keybindings.vala, do not modify */

/*
 * based on keyboard-shortcuts.c from gnome-control-center
 *
 * Copyright (c) 2013 gnome-pomodoro contributors
 *               2010 Intel, Inc
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *          Thomas Wood <thomas.wood@intel.com>
 *          Rodrigo Moya <rodrigo@gnome.org>
 */
/* TODO:
 * Handle integration with window manager
 *  - suppress any keybings from being triggered
 *  - if keybinding is taken, notify about it
 *
 * For now gnome-shell extension is responsible for setting it.
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>


#define POMODORO_TYPE_KEYBINDING (pomodoro_keybinding_get_type ())
#define POMODORO_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_KEYBINDING, PomodoroKeybinding))
#define POMODORO_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_KEYBINDING, PomodoroKeybindingClass))
#define POMODORO_IS_KEYBINDING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_KEYBINDING))
#define POMODORO_IS_KEYBINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_KEYBINDING))
#define POMODORO_KEYBINDING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_KEYBINDING, PomodoroKeybindingClass))

typedef struct _PomodoroKeybinding PomodoroKeybinding;
typedef struct _PomodoroKeybindingClass PomodoroKeybindingClass;
typedef struct _PomodoroKeybindingPrivate PomodoroKeybindingPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

typedef enum  {
	POMODORO_KEYBINDING_ERROR_INVALID,
	POMODORO_KEYBINDING_ERROR_FORBIDDEN,
	POMODORO_KEYBINDING_ERROR_TYPING_COLLISION
} PomodoroKeybindingError;
#define POMODORO_KEYBINDING_ERROR pomodoro_keybinding_error_quark ()
struct _PomodoroKeybinding {
	GObject parent_instance;
	PomodoroKeybindingPrivate * priv;
};

struct _PomodoroKeybindingClass {
	GObjectClass parent_class;
};

struct _PomodoroKeybindingPrivate {
	guint _key;
	GdkModifierType _modifiers;
};


static gpointer pomodoro_keybinding_parent_class = NULL;

GQuark pomodoro_keybinding_error_quark (void);
GType pomodoro_keybinding_get_type (void) G_GNUC_CONST;
#define POMODORO_KEYBINDING_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POMODORO_TYPE_KEYBINDING, PomodoroKeybindingPrivate))
enum  {
	POMODORO_KEYBINDING_DUMMY_PROPERTY,
	POMODORO_KEYBINDING_KEY,
	POMODORO_KEYBINDING_MODIFIERS,
	POMODORO_KEYBINDING_ACCELERATOR
};
PomodoroKeybinding* pomodoro_keybinding_new (guint key, GdkModifierType modifiers);
PomodoroKeybinding* pomodoro_keybinding_construct (GType object_type, guint key, GdkModifierType modifiers);
static void pomodoro_keybinding_set_key (PomodoroKeybinding* self, guint value);
static void pomodoro_keybinding_set_modifiers (PomodoroKeybinding* self, GdkModifierType value);
PomodoroKeybinding* pomodoro_keybinding_new_from_string (const gchar* str);
PomodoroKeybinding* pomodoro_keybinding_construct_from_string (GType object_type, const gchar* str);
void pomodoro_keybinding_set_accelerator (PomodoroKeybinding* self, const gchar* value);
void pomodoro_keybinding_parse (const gchar* str, guint* keyval, GdkModifierType* modifiers);
void pomodoro_keybinding_set_values (PomodoroKeybinding* self, guint key, GdkModifierType modifiers);
void pomodoro_keybinding_verify (PomodoroKeybinding* self, GError** error);
guint pomodoro_keybinding_get_key (PomodoroKeybinding* self);
GdkModifierType pomodoro_keybinding_get_modifiers (PomodoroKeybinding* self);
static GList* pomodoro_keybinding_get_string_list (PomodoroKeybinding* self, gboolean escape_modifiers);
static void _g_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
gchar* pomodoro_keybinding_get_label (PomodoroKeybinding* self);
gchar* pomodoro_keybinding_get_accelerator (PomodoroKeybinding* self);
static void pomodoro_keybinding_finalize (GObject* obj);
static void _vala_pomodoro_keybinding_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_pomodoro_keybinding_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GQuark pomodoro_keybinding_error_quark (void) {
	return g_quark_from_static_string ("pomodoro_keybinding_error-quark");
}


PomodoroKeybinding* pomodoro_keybinding_construct (GType object_type, guint key, GdkModifierType modifiers) {
	PomodoroKeybinding * self = NULL;
	guint _tmp0_ = 0U;
	GdkModifierType _tmp1_ = 0;
	self = (PomodoroKeybinding*) g_object_new (object_type, NULL);
	_tmp0_ = key;
	pomodoro_keybinding_set_key (self, _tmp0_);
	_tmp1_ = modifiers;
	pomodoro_keybinding_set_modifiers (self, _tmp1_);
	return self;
}


PomodoroKeybinding* pomodoro_keybinding_new (guint key, GdkModifierType modifiers) {
	return pomodoro_keybinding_construct (POMODORO_TYPE_KEYBINDING, key, modifiers);
}


PomodoroKeybinding* pomodoro_keybinding_construct_from_string (GType object_type, const gchar* str) {
	PomodoroKeybinding * self = NULL;
	const gchar* _tmp0_ = NULL;
	self = (PomodoroKeybinding*) g_object_new (object_type, NULL);
	_tmp0_ = str;
	pomodoro_keybinding_set_accelerator (self, _tmp0_);
	return self;
}


PomodoroKeybinding* pomodoro_keybinding_new_from_string (const gchar* str) {
	return pomodoro_keybinding_construct_from_string (POMODORO_TYPE_KEYBINDING, str);
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_ = 0L;
	gchar _tmp1_ = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	glong _tmp2_ = 0L;
	glong _tmp5_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	glong _tmp14_ = 0L;
	gboolean _tmp17_ = FALSE;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	glong _tmp22_ = 0L;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_ = 0L;
		glong _tmp7_ = 0L;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	_tmp12_ = _tmp8_;
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp14_ = end;
	if (_tmp14_ >= ((glong) 0)) {
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
		_tmp15_ = end;
		_tmp16_ = string_length;
		_tmp13_ = _tmp15_ <= _tmp16_;
	} else {
		_tmp13_ = FALSE;
	}
	_tmp17_ = _tmp13_;
	g_return_val_if_fail (_tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	g_return_val_if_fail (_tmp18_ <= _tmp19_, NULL);
	_tmp20_ = start;
	_tmp21_ = end;
	_tmp22_ = start;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) (_tmp21_ - _tmp22_));
	result = _tmp23_;
	return result;
}


void pomodoro_keybinding_parse (const gchar* str, guint* keyval, GdkModifierType* modifiers) {
	guint _vala_keyval = 0U;
	GdkModifierType _vala_modifiers = 0;
	gint pos = 0;
	gint start = 0;
	gchar chr = '\0';
	gboolean is_modifier = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp28_ = NULL;
	gint _tmp29_ = 0;
	gint _tmp30_ = 0;
	gchar* _tmp31_ = NULL;
	gchar* _tmp32_ = NULL;
	guint _tmp33_ = 0U;
	pos = 0;
	start = 0;
	chr = '\0';
	is_modifier = FALSE;
	_vala_keyval = (guint) 0;
	_vala_modifiers = 0;
	_tmp0_ = str;
	if (_tmp0_ == NULL) {
		if (keyval) {
			*keyval = _vala_keyval;
		}
		if (modifiers) {
			*modifiers = _vala_modifiers;
		}
		return;
	}
	while (TRUE) {
		const gchar* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		gchar _tmp3_ = '\0';
		gchar _tmp4_ = '\0';
		gchar _tmp5_ = '\0';
		gint _tmp27_ = 0;
		_tmp1_ = str;
		_tmp2_ = pos;
		_tmp3_ = string_get (_tmp1_, (glong) _tmp2_);
		chr = _tmp3_;
		_tmp4_ = chr;
		if (!(_tmp4_ != '\0')) {
			break;
		}
		_tmp5_ = chr;
		if (_tmp5_ == '<') {
			gint _tmp6_ = 0;
			_tmp6_ = pos;
			start = _tmp6_ + 1;
			is_modifier = TRUE;
		} else {
			gboolean _tmp7_ = FALSE;
			gchar _tmp8_ = '\0';
			gboolean _tmp10_ = FALSE;
			_tmp8_ = chr;
			if (_tmp8_ == '>') {
				gboolean _tmp9_ = FALSE;
				_tmp9_ = is_modifier;
				_tmp7_ = _tmp9_;
			} else {
				_tmp7_ = FALSE;
			}
			_tmp10_ = _tmp7_;
			if (_tmp10_) {
				gchar* modifier = NULL;
				const gchar* _tmp11_ = NULL;
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
				gchar* _tmp14_ = NULL;
				gboolean _tmp15_ = FALSE;
				const gchar* _tmp16_ = NULL;
				gboolean _tmp18_ = FALSE;
				const gchar* _tmp20_ = NULL;
				const gchar* _tmp22_ = NULL;
				const gchar* _tmp24_ = NULL;
				gint _tmp26_ = 0;
				_tmp11_ = str;
				_tmp12_ = start;
				_tmp13_ = pos;
				_tmp14_ = string_slice (_tmp11_, (glong) _tmp12_, (glong) _tmp13_);
				modifier = _tmp14_;
				_tmp16_ = modifier;
				if (g_strcmp0 (_tmp16_, "Ctrl") == 0) {
					_tmp15_ = TRUE;
				} else {
					const gchar* _tmp17_ = NULL;
					_tmp17_ = modifier;
					_tmp15_ = g_strcmp0 (_tmp17_, "Control") == 0;
				}
				_tmp18_ = _tmp15_;
				if (_tmp18_) {
					GdkModifierType _tmp19_ = 0;
					_tmp19_ = _vala_modifiers;
					_vala_modifiers = _tmp19_ | GDK_CONTROL_MASK;
				}
				_tmp20_ = modifier;
				if (g_strcmp0 (_tmp20_, "Alt") == 0) {
					GdkModifierType _tmp21_ = 0;
					_tmp21_ = _vala_modifiers;
					_vala_modifiers = _tmp21_ | GDK_MOD1_MASK;
				}
				_tmp22_ = modifier;
				if (g_strcmp0 (_tmp22_, "Shift") == 0) {
					GdkModifierType _tmp23_ = 0;
					_tmp23_ = _vala_modifiers;
					_vala_modifiers = _tmp23_ | GDK_SHIFT_MASK;
				}
				_tmp24_ = modifier;
				if (g_strcmp0 (_tmp24_, "Super") == 0) {
					GdkModifierType _tmp25_ = 0;
					_tmp25_ = _vala_modifiers;
					_vala_modifiers = _tmp25_ | GDK_SUPER_MASK;
				}
				is_modifier = FALSE;
				_tmp26_ = pos;
				start = _tmp26_ + 1;
				_g_free0 (modifier);
			}
		}
		_tmp27_ = pos;
		pos = _tmp27_ + 1;
	}
	_tmp28_ = str;
	_tmp29_ = start;
	_tmp30_ = pos;
	_tmp31_ = string_slice (_tmp28_, (glong) _tmp29_, (glong) _tmp30_);
	_tmp32_ = _tmp31_;
	_tmp33_ = gdk_keyval_from_name (_tmp32_);
	_vala_keyval = _tmp33_;
	_g_free0 (_tmp32_);
	if (keyval) {
		*keyval = _vala_keyval;
	}
	if (modifiers) {
		*modifiers = _vala_modifiers;
	}
}


void pomodoro_keybinding_set_values (PomodoroKeybinding* self, guint key, GdkModifierType modifiers) {
	guint _tmp0_ = 0U;
	GdkModifierType _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = key;
	pomodoro_keybinding_set_key (self, _tmp0_);
	_tmp1_ = modifiers;
	pomodoro_keybinding_set_modifiers (self, _tmp1_ & (((GDK_SHIFT_MASK | GDK_CONTROL_MASK) | GDK_SUPER_MASK) | GDK_MOD1_MASK));
	g_object_notify ((GObject*) self, "accelerator");
	g_signal_emit_by_name (self, "changed");
}


void pomodoro_keybinding_verify (PomodoroKeybinding* self, GError** error) {
	guint key = 0U;
	guint _tmp0_ = 0U;
	GdkModifierType modifiers = 0;
	GdkModifierType _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_key;
	key = _tmp0_;
	_tmp1_ = self->priv->_modifiers;
	modifiers = _tmp1_;
	_tmp2_ = gtk_accelerator_valid (key, modifiers);
	if (!_tmp2_) {
		GError* _tmp3_ = NULL;
		_tmp3_ = g_error_new_literal (POMODORO_KEYBINDING_ERROR, POMODORO_KEYBINDING_ERROR_INVALID, "Invalid");
		_inner_error_ = _tmp3_;
		if (_inner_error_->domain == POMODORO_KEYBINDING_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (modifiers == 0) {
		_tmp4_ = key != ((guint) 0);
	} else {
		_tmp4_ = FALSE;
	}
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		if (key == ((guint) GDK_KEY_Escape)) {
			_tmp7_ = TRUE;
		} else {
			_tmp7_ = key == ((guint) GDK_KEY_BackSpace);
		}
		_tmp8_ = _tmp7_;
		if (_tmp8_) {
			_tmp6_ = TRUE;
		} else {
			_tmp6_ = key == ((guint) GDK_KEY_Return);
		}
		_tmp9_ = _tmp6_;
		if (_tmp9_) {
			GError* _tmp10_ = NULL;
			_tmp10_ = g_error_new_literal (POMODORO_KEYBINDING_ERROR, POMODORO_KEYBINDING_ERROR_FORBIDDEN, "Forbidden");
			_inner_error_ = _tmp10_;
			if (_inner_error_->domain == POMODORO_KEYBINDING_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	if (modifiers == 0) {
		_tmp12_ = TRUE;
	} else {
		_tmp12_ = modifiers == GDK_SHIFT_MASK;
	}
	_tmp13_ = _tmp12_;
	if (_tmp13_) {
		_tmp11_ = key != ((guint) 0);
	} else {
		_tmp11_ = FALSE;
	}
	_tmp14_ = _tmp11_;
	if (_tmp14_) {
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		gboolean _tmp21_ = FALSE;
		gboolean _tmp22_ = FALSE;
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
		gboolean _tmp25_ = FALSE;
		gboolean _tmp26_ = FALSE;
		gboolean _tmp29_ = FALSE;
		gboolean _tmp32_ = FALSE;
		gboolean _tmp35_ = FALSE;
		gboolean _tmp38_ = FALSE;
		gboolean _tmp41_ = FALSE;
		gboolean _tmp44_ = FALSE;
		gboolean _tmp47_ = FALSE;
		gboolean _tmp50_ = FALSE;
		gboolean _tmp53_ = FALSE;
		gboolean _tmp56_ = FALSE;
		if (key >= ((guint) GDK_KEY_a)) {
			_tmp25_ = key <= ((guint) GDK_KEY_z);
		} else {
			_tmp25_ = FALSE;
		}
		_tmp26_ = _tmp25_;
		if (_tmp26_) {
			_tmp24_ = TRUE;
		} else {
			gboolean _tmp27_ = FALSE;
			gboolean _tmp28_ = FALSE;
			if (key >= ((guint) GDK_KEY_A)) {
				_tmp27_ = key <= ((guint) GDK_KEY_Z);
			} else {
				_tmp27_ = FALSE;
			}
			_tmp28_ = _tmp27_;
			_tmp24_ = _tmp28_;
		}
		_tmp29_ = _tmp24_;
		if (_tmp29_) {
			_tmp23_ = TRUE;
		} else {
			gboolean _tmp30_ = FALSE;
			gboolean _tmp31_ = FALSE;
			if (key >= ((guint) GDK_KEY_0)) {
				_tmp30_ = key <= ((guint) GDK_KEY_9);
			} else {
				_tmp30_ = FALSE;
			}
			_tmp31_ = _tmp30_;
			_tmp23_ = _tmp31_;
		}
		_tmp32_ = _tmp23_;
		if (_tmp32_) {
			_tmp22_ = TRUE;
		} else {
			gboolean _tmp33_ = FALSE;
			gboolean _tmp34_ = FALSE;
			if (key >= ((guint) GDK_KEY_kana_fullstop)) {
				_tmp33_ = key <= ((guint) GDK_KEY_semivoicedsound);
			} else {
				_tmp33_ = FALSE;
			}
			_tmp34_ = _tmp33_;
			_tmp22_ = _tmp34_;
		}
		_tmp35_ = _tmp22_;
		if (_tmp35_) {
			_tmp21_ = TRUE;
		} else {
			gboolean _tmp36_ = FALSE;
			gboolean _tmp37_ = FALSE;
			if (key >= ((guint) GDK_KEY_Arabic_comma)) {
				_tmp36_ = key <= ((guint) GDK_KEY_Arabic_sukun);
			} else {
				_tmp36_ = FALSE;
			}
			_tmp37_ = _tmp36_;
			_tmp21_ = _tmp37_;
		}
		_tmp38_ = _tmp21_;
		if (_tmp38_) {
			_tmp20_ = TRUE;
		} else {
			gboolean _tmp39_ = FALSE;
			gboolean _tmp40_ = FALSE;
			if (key >= ((guint) GDK_KEY_Serbian_dje)) {
				_tmp39_ = key <= ((guint) GDK_KEY_Cyrillic_HARDSIGN);
			} else {
				_tmp39_ = FALSE;
			}
			_tmp40_ = _tmp39_;
			_tmp20_ = _tmp40_;
		}
		_tmp41_ = _tmp20_;
		if (_tmp41_) {
			_tmp19_ = TRUE;
		} else {
			gboolean _tmp42_ = FALSE;
			gboolean _tmp43_ = FALSE;
			if (key >= ((guint) GDK_KEY_Greek_ALPHAaccent)) {
				_tmp42_ = key <= ((guint) GDK_KEY_Greek_omega);
			} else {
				_tmp42_ = FALSE;
			}
			_tmp43_ = _tmp42_;
			_tmp19_ = _tmp43_;
		}
		_tmp44_ = _tmp19_;
		if (_tmp44_) {
			_tmp18_ = TRUE;
		} else {
			gboolean _tmp45_ = FALSE;
			gboolean _tmp46_ = FALSE;
			if (key >= ((guint) GDK_KEY_hebrew_doublelowline)) {
				_tmp45_ = key <= ((guint) GDK_KEY_hebrew_taf);
			} else {
				_tmp45_ = FALSE;
			}
			_tmp46_ = _tmp45_;
			_tmp18_ = _tmp46_;
		}
		_tmp47_ = _tmp18_;
		if (_tmp47_) {
			_tmp17_ = TRUE;
		} else {
			gboolean _tmp48_ = FALSE;
			gboolean _tmp49_ = FALSE;
			if (key >= ((guint) GDK_KEY_Thai_kokai)) {
				_tmp48_ = key <= ((guint) GDK_KEY_Thai_lekkao);
			} else {
				_tmp48_ = FALSE;
			}
			_tmp49_ = _tmp48_;
			_tmp17_ = _tmp49_;
		}
		_tmp50_ = _tmp17_;
		if (_tmp50_) {
			_tmp16_ = TRUE;
		} else {
			gboolean _tmp51_ = FALSE;
			gboolean _tmp52_ = FALSE;
			if (key >= ((guint) GDK_KEY_Hangul)) {
				_tmp51_ = key <= ((guint) GDK_KEY_Hangul_Special);
			} else {
				_tmp51_ = FALSE;
			}
			_tmp52_ = _tmp51_;
			_tmp16_ = _tmp52_;
		}
		_tmp53_ = _tmp16_;
		if (_tmp53_) {
			_tmp15_ = TRUE;
		} else {
			gboolean _tmp54_ = FALSE;
			gboolean _tmp55_ = FALSE;
			if (key >= ((guint) GDK_KEY_Hangul_Kiyeog)) {
				_tmp54_ = key <= ((guint) GDK_KEY_Hangul_J_YeorinHieuh);
			} else {
				_tmp54_ = FALSE;
			}
			_tmp55_ = _tmp54_;
			_tmp15_ = _tmp55_;
		}
		_tmp56_ = _tmp15_;
		if (_tmp56_) {
			GError* _tmp57_ = NULL;
			_tmp57_ = g_error_new_literal (POMODORO_KEYBINDING_ERROR, POMODORO_KEYBINDING_ERROR_TYPING_COLLISION, "Typing collision");
			_inner_error_ = _tmp57_;
			if (_inner_error_->domain == POMODORO_KEYBINDING_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_list_free__g_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
	g_list_free (self);
}


static GList* pomodoro_keybinding_get_string_list (PomodoroKeybinding* self, gboolean escape_modifiers) {
	GList* result = NULL;
	GList* elements = NULL;
	GdkModifierType _tmp0_ = 0;
	GdkModifierType _tmp5_ = 0;
	GdkModifierType _tmp10_ = 0;
	GdkModifierType _tmp15_ = 0;
	guint _tmp20_ = 0U;
	g_return_val_if_fail (self != NULL, NULL);
	elements = NULL;
	_tmp0_ = self->priv->_modifiers;
	if ((_tmp0_ & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
		const gchar* _tmp1_ = NULL;
		gboolean _tmp2_ = FALSE;
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		_tmp2_ = escape_modifiers;
		if (_tmp2_) {
			_tmp1_ = "<Shift>";
		} else {
			_tmp1_ = "Shift";
		}
		_tmp3_ = _tmp1_;
		_tmp4_ = g_strdup (_tmp3_);
		elements = g_list_append (elements, _tmp4_);
	}
	_tmp5_ = self->priv->_modifiers;
	if ((_tmp5_ & GDK_SUPER_MASK) == GDK_SUPER_MASK) {
		const gchar* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp7_ = escape_modifiers;
		if (_tmp7_) {
			_tmp6_ = "<Super>";
		} else {
			_tmp6_ = "Super";
		}
		_tmp8_ = _tmp6_;
		_tmp9_ = g_strdup (_tmp8_);
		elements = g_list_append (elements, _tmp9_);
	}
	_tmp10_ = self->priv->_modifiers;
	if ((_tmp10_ & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
		const gchar* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		_tmp12_ = escape_modifiers;
		if (_tmp12_) {
			_tmp11_ = "<Ctrl>";
		} else {
			_tmp11_ = "Ctrl";
		}
		_tmp13_ = _tmp11_;
		_tmp14_ = g_strdup (_tmp13_);
		elements = g_list_append (elements, _tmp14_);
	}
	_tmp15_ = self->priv->_modifiers;
	if ((_tmp15_ & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
		const gchar* _tmp16_ = NULL;
		gboolean _tmp17_ = FALSE;
		const gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		_tmp17_ = escape_modifiers;
		if (_tmp17_) {
			_tmp16_ = "<Alt>";
		} else {
			_tmp16_ = "Alt";
		}
		_tmp18_ = _tmp16_;
		_tmp19_ = g_strdup (_tmp18_);
		elements = g_list_append (elements, _tmp19_);
	}
	_tmp20_ = self->priv->_key;
	if (_tmp20_ != ((guint) 0)) {
		guint keyval = 0U;
		guint _tmp21_ = 0U;
		guint _tmp22_ = 0U;
		guint _tmp23_ = 0U;
		const gchar* _tmp24_ = NULL;
		gchar* _tmp25_ = NULL;
		_tmp21_ = self->priv->_key;
		_tmp22_ = gdk_keyval_to_upper (_tmp21_);
		keyval = _tmp22_;
		_tmp23_ = keyval;
		_tmp24_ = gdk_keyval_name (_tmp23_);
		_tmp25_ = g_strdup (_tmp24_);
		elements = g_list_append (elements, _tmp25_);
	}
	result = elements;
	return result;
}


gchar* pomodoro_keybinding_get_label (PomodoroKeybinding* self) {
	gchar* result = NULL;
	GString* label = NULL;
	GString* _tmp0_ = NULL;
	gboolean is_first = FALSE;
	GList* _tmp1_ = NULL;
	GString* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	label = _tmp0_;
	is_first = TRUE;
	_tmp1_ = pomodoro_keybinding_get_string_list (self, FALSE);
	{
		GList* element_collection = NULL;
		GList* element_it = NULL;
		element_collection = _tmp1_;
		for (element_it = element_collection; element_it != NULL; element_it = element_it->next) {
			gchar* _tmp2_ = NULL;
			gchar* element = NULL;
			_tmp2_ = g_strdup ((const gchar*) element_it->data);
			element = _tmp2_;
			{
				gboolean _tmp3_ = FALSE;
				GString* _tmp5_ = NULL;
				const gchar* _tmp6_ = NULL;
				_tmp3_ = is_first;
				if (!_tmp3_) {
					GString* _tmp4_ = NULL;
					_tmp4_ = label;
					g_string_append (_tmp4_, "+");
				} else {
					is_first = FALSE;
				}
				_tmp5_ = label;
				_tmp6_ = element;
				g_string_append (_tmp5_, _tmp6_);
				_g_free0 (element);
			}
		}
		__g_list_free__g_free0_0 (element_collection);
	}
	_tmp7_ = label;
	_tmp8_ = _tmp7_->str;
	_tmp9_ = g_strdup (_tmp8_);
	result = _tmp9_;
	_g_string_free0 (label);
	return result;
}


guint pomodoro_keybinding_get_key (PomodoroKeybinding* self) {
	guint result;
	guint _tmp0_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_key;
	result = _tmp0_;
	return result;
}


static void pomodoro_keybinding_set_key (PomodoroKeybinding* self, guint value) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_key = _tmp0_;
	g_object_notify ((GObject *) self, "key");
}


GdkModifierType pomodoro_keybinding_get_modifiers (PomodoroKeybinding* self) {
	GdkModifierType result;
	GdkModifierType _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_modifiers;
	result = _tmp0_;
	return result;
}


static void pomodoro_keybinding_set_modifiers (PomodoroKeybinding* self, GdkModifierType value) {
	GdkModifierType _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_modifiers = _tmp0_;
	g_object_notify ((GObject *) self, "modifiers");
}


gchar* pomodoro_keybinding_get_accelerator (PomodoroKeybinding* self) {
	gchar* result;
	GString* accelerator = NULL;
	GString* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	GString* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	accelerator = _tmp0_;
	_tmp1_ = pomodoro_keybinding_get_string_list (self, TRUE);
	{
		GList* element_collection = NULL;
		GList* element_it = NULL;
		element_collection = _tmp1_;
		for (element_it = element_collection; element_it != NULL; element_it = element_it->next) {
			gchar* _tmp2_ = NULL;
			gchar* element = NULL;
			_tmp2_ = g_strdup ((const gchar*) element_it->data);
			element = _tmp2_;
			{
				GString* _tmp3_ = NULL;
				const gchar* _tmp4_ = NULL;
				_tmp3_ = accelerator;
				_tmp4_ = element;
				g_string_append (_tmp3_, _tmp4_);
				_g_free0 (element);
			}
		}
		__g_list_free__g_free0_0 (element_collection);
	}
	_tmp5_ = accelerator;
	_tmp6_ = _tmp5_->str;
	_tmp7_ = g_strdup (_tmp6_);
	result = _tmp7_;
	_g_string_free0 (accelerator);
	return result;
}


void pomodoro_keybinding_set_accelerator (PomodoroKeybinding* self, const gchar* value) {
	guint key = 0U;
	GdkModifierType modifiers = 0;
	const gchar* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	GdkModifierType _tmp2_ = 0;
	guint _tmp3_ = 0U;
	GdkModifierType _tmp4_ = 0;
	g_return_if_fail (self != NULL);
	key = (guint) 0;
	modifiers = 0;
	_tmp0_ = value;
	pomodoro_keybinding_parse (_tmp0_, &_tmp1_, &_tmp2_);
	key = _tmp1_;
	modifiers = _tmp2_;
	_tmp3_ = key;
	pomodoro_keybinding_set_key (self, _tmp3_);
	_tmp4_ = modifiers;
	pomodoro_keybinding_set_modifiers (self, _tmp4_);
	g_signal_emit_by_name (self, "changed");
	g_object_notify ((GObject *) self, "accelerator");
}


static void pomodoro_keybinding_class_init (PomodoroKeybindingClass * klass) {
	pomodoro_keybinding_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PomodoroKeybindingPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_keybinding_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_keybinding_set_property;
	G_OBJECT_CLASS (klass)->finalize = pomodoro_keybinding_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_KEYBINDING_KEY, g_param_spec_uint ("key", "key", "key", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_KEYBINDING_MODIFIERS, g_param_spec_flags ("modifiers", "modifiers", "modifiers", gdk_modifier_type_get_type (), 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_KEYBINDING_ACCELERATOR, g_param_spec_string ("accelerator", "accelerator", "accelerator", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("changed", POMODORO_TYPE_KEYBINDING, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void pomodoro_keybinding_instance_init (PomodoroKeybinding * self) {
	self->priv = POMODORO_KEYBINDING_GET_PRIVATE (self);
}


static void pomodoro_keybinding_finalize (GObject* obj) {
	PomodoroKeybinding * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_KEYBINDING, PomodoroKeybinding);
	G_OBJECT_CLASS (pomodoro_keybinding_parent_class)->finalize (obj);
}


GType pomodoro_keybinding_get_type (void) {
	static volatile gsize pomodoro_keybinding_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_keybinding_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PomodoroKeybindingClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_keybinding_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroKeybinding), 0, (GInstanceInitFunc) pomodoro_keybinding_instance_init, NULL };
		GType pomodoro_keybinding_type_id;
		pomodoro_keybinding_type_id = g_type_register_static (G_TYPE_OBJECT, "PomodoroKeybinding", &g_define_type_info, 0);
		g_once_init_leave (&pomodoro_keybinding_type_id__volatile, pomodoro_keybinding_type_id);
	}
	return pomodoro_keybinding_type_id__volatile;
}


static void _vala_pomodoro_keybinding_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PomodoroKeybinding * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_KEYBINDING, PomodoroKeybinding);
	switch (property_id) {
		case POMODORO_KEYBINDING_KEY:
		g_value_set_uint (value, pomodoro_keybinding_get_key (self));
		break;
		case POMODORO_KEYBINDING_MODIFIERS:
		g_value_set_flags (value, pomodoro_keybinding_get_modifiers (self));
		break;
		case POMODORO_KEYBINDING_ACCELERATOR:
		g_value_take_string (value, pomodoro_keybinding_get_accelerator (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_pomodoro_keybinding_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PomodoroKeybinding * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_KEYBINDING, PomodoroKeybinding);
	switch (property_id) {
		case POMODORO_KEYBINDING_KEY:
		pomodoro_keybinding_set_key (self, g_value_get_uint (value));
		break;
		case POMODORO_KEYBINDING_MODIFIERS:
		pomodoro_keybinding_set_modifiers (self, g_value_get_flags (value));
		break;
		case POMODORO_KEYBINDING_ACCELERATOR:
		pomodoro_keybinding_set_accelerator (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



