/* utils.c generated by valac 0.22.1, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * Copyright (c) 2013 gnome-pomodoro contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

typedef enum  {
	POMODORO_DATE_TIME_ERROR_PARSE
} PomodoroDateTimeError;
#define POMODORO_DATE_TIME_ERROR pomodoro_date_time_error_quark ()


#define POMODORO_DATETIME_FORMAT_RFC_2822 "%a, %d %b %Y %H:%M:%S GMT"
GQuark pomodoro_date_time_error_quark (void);
GDateTime* pomodoro_datetime_from_string (const gchar* date_str, GError** error);
gchar* pomodoro_datetime_to_string (GDateTime* datetime);
gchar* pomodoro_format_time (glong seconds);
gdouble pomodoro_get_real_time (void);

const gchar* POMODORO_DATETIME_ABBREVIATED_MONTH_NAMES[12] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

GQuark pomodoro_date_time_error_quark (void) {
	return g_quark_from_static_string ("pomodoro_date_time_error-quark");
}


GDateTime* pomodoro_datetime_from_string (const gchar* date_str, GError** error) {
	GDateTime* result = NULL;
	gchar* day_name = NULL;
	gchar* _tmp0_ = NULL;
	gchar* month_name = NULL;
	gchar* _tmp1_ = NULL;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minutes = 0;
	gdouble seconds = 0.0;
	gint length = 0;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gboolean _tmp15_ = FALSE;
	gint _tmp16_ = 0;
	gboolean _tmp18_ = FALSE;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	gdouble _tmp26_ = 0.0;
	GDateTime* _tmp27_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (date_str != NULL, NULL);
	_tmp0_ = g_strdup ("");
	day_name = _tmp0_;
	_tmp1_ = g_strdup ("");
	month_name = _tmp1_;
	year = 0;
	month = 0;
	day = 0;
	hour = 0;
	minutes = 0;
	seconds = 0.0;
	_tmp2_ = date_str;
	_tmp3_ = day_name;
	_tmp4_ = month_name;
	_tmp5_ = sscanf (_tmp2_, "%[^,], %2d %s %4d %02d:%02d:%02lf", _tmp3_, &day, _tmp4_, &year, &hour, &minutes, &seconds);
	length = _tmp5_;
	_tmp6_ = length;
	if (_tmp6_ >= 3) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp7_ = FALSE;
				_tmp7_ = TRUE;
				while (TRUE) {
					gboolean _tmp8_ = FALSE;
					gint _tmp10_ = 0;
					const gchar* _tmp11_ = NULL;
					gint _tmp12_ = 0;
					const gchar* _tmp13_ = NULL;
					_tmp8_ = _tmp7_;
					if (!_tmp8_) {
						gint _tmp9_ = 0;
						_tmp9_ = i;
						i = _tmp9_ + 1;
					}
					_tmp7_ = FALSE;
					_tmp10_ = i;
					if (!(_tmp10_ < G_N_ELEMENTS (POMODORO_DATETIME_ABBREVIATED_MONTH_NAMES))) {
						break;
					}
					_tmp11_ = month_name;
					_tmp12_ = i;
					_tmp13_ = POMODORO_DATETIME_ABBREVIATED_MONTH_NAMES[_tmp12_];
					if (g_strcmp0 (_tmp11_, _tmp13_) == 0) {
						gint _tmp14_ = 0;
						_tmp14_ = i;
						month = _tmp14_ + 1;
						break;
					}
				}
			}
		}
	}
	_tmp16_ = length;
	if (_tmp16_ < 7) {
		_tmp15_ = TRUE;
	} else {
		gint _tmp17_ = 0;
		_tmp17_ = month;
		_tmp15_ = _tmp17_ == 0;
	}
	_tmp18_ = _tmp15_;
	if (_tmp18_) {
		const gchar* _tmp19_ = NULL;
		GError* _tmp20_ = NULL;
		_tmp19_ = date_str;
		_tmp20_ = g_error_new (POMODORO_DATE_TIME_ERROR, POMODORO_DATE_TIME_ERROR_PARSE, "Could not parse string '%s'", _tmp19_);
		_inner_error_ = _tmp20_;
		if (_inner_error_->domain == POMODORO_DATE_TIME_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (month_name);
			_g_free0 (day_name);
			return NULL;
		} else {
			_g_free0 (month_name);
			_g_free0 (day_name);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp21_ = year;
	_tmp22_ = month;
	_tmp23_ = day;
	_tmp24_ = hour;
	_tmp25_ = minutes;
	_tmp26_ = seconds;
	_tmp27_ = g_date_time_new_utc (_tmp21_, _tmp22_, _tmp23_, _tmp24_, _tmp25_, _tmp26_);
	result = _tmp27_;
	_g_free0 (month_name);
	_g_free0 (day_name);
	return result;
}


gchar* pomodoro_datetime_to_string (GDateTime* datetime) {
	gchar* result = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	GDateTime* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	g_return_val_if_fail (datetime != NULL, NULL);
	_tmp0_ = datetime;
	_tmp1_ = g_date_time_to_utc (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_date_time_format (_tmp2_, POMODORO_DATETIME_FORMAT_RFC_2822);
	_tmp4_ = _tmp3_;
	_g_date_time_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}


gchar* pomodoro_format_time (glong seconds) {
	gchar* result = NULL;
	glong minutes = 0L;
	glong _tmp0_ = 0L;
	glong hours = 0L;
	glong _tmp1_ = 0L;
	gchar* str = NULL;
	gchar* _tmp2_ = NULL;
	glong _tmp3_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp11_ = FALSE;
	glong _tmp14_ = 0L;
	_tmp0_ = seconds;
	minutes = (_tmp0_ / 60) % 60;
	_tmp1_ = seconds;
	hours = _tmp1_ / 3600;
	_tmp2_ = g_strdup ("");
	str = _tmp2_;
	_tmp3_ = hours;
	if (_tmp3_ > ((glong) 0)) {
		glong _tmp4_ = 0L;
		const gchar* _tmp5_ = NULL;
		glong _tmp6_ = 0L;
		gchar* _tmp7_ = NULL;
		_tmp4_ = hours;
		_tmp5_ = ngettext ("%d hour", "%d hours", (gulong) _tmp4_);
		_tmp6_ = hours;
		_tmp7_ = g_strdup_printf (_tmp5_, _tmp6_);
		_g_free0 (str);
		str = _tmp7_;
	}
	_tmp9_ = minutes;
	if (_tmp9_ > ((glong) 0)) {
		const gchar* _tmp10_ = NULL;
		_tmp10_ = str;
		_tmp8_ = _tmp10_ != NULL;
	} else {
		_tmp8_ = FALSE;
	}
	_tmp11_ = _tmp8_;
	if (_tmp11_) {
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		_tmp12_ = str;
		_tmp13_ = g_strconcat (_tmp12_, " ", NULL);
		_g_free0 (str);
		str = _tmp13_;
	}
	_tmp14_ = minutes;
	if (_tmp14_ > ((glong) 0)) {
		const gchar* _tmp15_ = NULL;
		glong _tmp16_ = 0L;
		const gchar* _tmp17_ = NULL;
		glong _tmp18_ = 0L;
		gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		_tmp15_ = str;
		_tmp16_ = minutes;
		_tmp17_ = ngettext ("%d minute", "%d minutes", (gulong) _tmp16_);
		_tmp18_ = minutes;
		_tmp19_ = g_strdup_printf (_tmp17_, _tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_strconcat (_tmp15_, _tmp20_, NULL);
		_g_free0 (str);
		str = _tmp21_;
		_g_free0 (_tmp20_);
	}
	result = str;
	return result;
}


gdouble pomodoro_get_real_time (void) {
	gdouble result = 0.0;
	gint64 _tmp0_ = 0LL;
	_tmp0_ = g_get_real_time ();
	result = ((gdouble) _tmp0_) / 1000000.0;
	return result;
}



